Why Angular Teams Choose ApexGantt

The ngx-apexgantt package exposes the chart as a real Angular component, <ngx-apexgantt>, with typed Inputs, EventEmitter Outputs, @ViewChild access, and first-class support for both standalone and module-based applications, not a thin shell around an imperative library that leaves you fighting ngOnDestroy, change detection, and zone leaks. It shares its core engine with ApexGantt's React, Vue, and JavaScript wrappers, so the task data model stays consistent if your stack grows beyond Angular. Learn about the full ApexGantt component →

Drag-and-Drop Scheduling with Typed Outputs

Drag tasks to reschedule, resize bars, and draw dependency arrows on the timeline. Each interaction fires an EventEmitter Output (taskDragged, taskResized, taskUpdateSuccess) you bind with (event)= syntax to persist edits or trigger workflows. Watch the scripted plan move, then grab a bar yourself.


Critical Path That Recomputes on Every Edit

ApexGantt highlights the longest chain of dependent tasks that drives your finish date. Update the [tasks] binding or call update() through @ViewChild and the critical path recomputes automatically. Watch it re-route between the two branches below.


Baselines for Planned vs. Actual

Attach a planned (baseline) range to each task in the same tasks array and ApexGantt draws a thin reference bar beneath the live one, so schedule variance is visible at a glance. No separate data structure required. The demo drifts the actuals past plan to show a slipping project.


Multiple View Modes via a Single Input

Bind the [pixelsPerDay] Input (a number; the header tier auto-picks from year down to minute) to control timeline density; change detection picks it up with no data re-query. This one auto-zooms; interact to take the controls.

Task Dependencies

Finish-to-start, start-to-start, and finish-to-finish links with lag, set on the [tasks] you bind.

Milestones

Zero-duration diamond markers for gates, releases, and key dates.

Annotations

Pin sprint boundaries, deadlines, or notes to specific dates through the options Input.

Configurable Columns

Define the task-table columns with columnConfig and the ColumnKey enum.

Rich HTML Tooltips

Templatable tooltips showing dates, duration, progress, and dependencies.

Custom Colors & Dark Theme

Bind the [theme] Input; deeper styling via the options object (GanttOptions).

SVG Export

Export timelines to high-quality SVG with every task and dependency preserved.

TypeScript Types

Definitions ship for NgxApexGanttComponent, GanttOptions, TaskInput, ColumnKey, and the event detail types.

Install in Your Angular App

ApexGantt for Angular requires two packages: the Angular wrapper and the core engine.

npm install ngx-apexgantt apexgantt
# or
yarn add ngx-apexgantt apexgantt

A complete working Gantt chart in one standalone component:

import { Component } from "@angular/core"
import { NgxApexGanttComponent, TaskInput } from "ngx-apexgantt"

@Component({
  selector: "app-timeline",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `
    <ngx-apexgantt
      [tasks]="tasks"
      [pixelsPerDay]="25.7"
      [height]="'500px'"
    ></ngx-apexgantt>
  `
})
export class TimelineComponent {
  tasks: TaskInput[] = [
    { id: "task-1", name: "Design",      startTime: "01-01-2026", endTime: "01-15-2026", progress: 75 },
    { id: "task-2", name: "Development", startTime: "01-16-2026", endTime: "02-28-2026", progress: 40, dependency: "task-1" },
    { id: "task-3", name: "QA",          startTime: "03-01-2026", endTime: "03-15-2026", progress: 0,  dependency: "task-2" }
  ]
}

For a module-based app, import NgxApexGanttModule into the relevant @NgModule instead. The pixelsPerDay Input takes a number; the header tier auto-picks from year down to minute as the value increases.

Working with @ViewChild and Events

ApexGantt's Outputs keep your Angular state in sync with the timeline, and a @ViewChild reference drives the chart imperatively when you need it:

import { Component, ViewChild } from "@angular/core"
import {
  NgxApexGanttComponent,
  TaskInput,
  TaskDraggedEventDetail,
  TaskResizedEventDetail,
  TaskUpdateSuccessEventDetail
} from "ngx-apexgantt"

@Component({
  selector: "app-schedule-editor",
  standalone: true,
  imports: [NgxApexGanttComponent],
  template: `
    <button (click)="ganttChart.zoomIn()">Zoom In</button>
    <button (click)="ganttChart.zoomOut()">Zoom Out</button>

    <ngx-apexgantt
      #ganttChart
      [tasks]="tasks"
      [pixelsPerDay]="25.7"
      [height]="'600px'"
      (taskDragged)="onTaskDragged($event)"
      (taskResized)="onTaskResized($event)"
      (taskUpdateSuccess)="onTaskUpdateSuccess($event)"
    ></ngx-apexgantt>
  `
})
export class ScheduleEditorComponent {
  @ViewChild("ganttChart") ganttChart!: NgxApexGanttComponent

  tasks: TaskInput[] = [/* ... */]

  onTaskDragged(event: TaskDraggedEventDetail) { console.log("dragged", event) }
  onTaskResized(event: TaskResizedEventDetail) { console.log("resized", event) }
  onTaskUpdateSuccess(event: TaskUpdateSuccessEventDetail) {
    // persist to your backend
    fetch(`/api/tasks/${event.taskId}`, { method: "PATCH", body: JSON.stringify(event.updatedTask) })
  }
}

v1.1.0 exposes three Outputs (taskUpdateSuccess, taskDragged, taskResized) and the @ViewChild methods update, updateTask, zoomIn, zoomOut, and destroy. Payloads match the shipped detail types: taskUpdateSuccess carries { taskId, updatedTask, timestamp }.

Customization, Theming, and Columns

Bind [theme]="'dark'" for a one-line theme switch. For deeper control, pass a GanttOptions object through the options Input and configure the task table with columnConfig and the ColumnKey enum:

import { GanttOptions, ColumnKey } from "ngx-apexgantt"

ganttOptions: GanttOptions = {
  series: this.tasks,
  enableToolbar: true,
  enableTaskDrag: true,
  enableTaskResize: true,
  barBackgroundColor: "#537CFA",
  rowHeight: 32,
  columnConfig: [
    { key: ColumnKey.Name,      title: "Task Name", minWidth: "100px", flexGrow: 3 },
    { key: ColumnKey.StartTime, title: "Start",     minWidth: "100px", flexGrow: 1.5 },
    { key: ColumnKey.Duration,  title: "Duration",  minWidth: "80px",  flexGrow: 1 }
  ]
}

Mapping Your API Shape Inline

API responses rarely match the field names ApexGantt expects. Add a parsing config inside GanttOptions to map your shape without hand-written transformation code:

ganttOptions: GanttOptions = {
  series: this.apiData,  // raw API response
  parsing: {
    id:        "task_id",
    name:      "task_name",
    startTime: "start_date",
    endTime:   "end_date",
    progress:  "completion"
  },
  height: "500px"
}

TypeScript Support in Angular

ngx-apexgantt ships TypeScript definitions for the component, the task data model, configuration, view modes, the column-key enum, and the event detail types:

import {
  NgxApexGanttComponent,
  GanttOptions,
  TaskInput,
  ColumnKey,
  TaskUpdateSuccessEventDetail,
  TaskDraggedEventDetail
} from "ngx-apexgantt"

ngx-apexgantt v1.1.0 targets Angular 18 (@angular/core and @angular/common ^18.0.0 peer dependencies).

Commercial License Setup

If you have a commercial ApexGantt license, set it once with the static setter, called before bootstrapApplication:

// main.ts
import { bootstrapApplication } from "@angular/platform-browser"
import { setApexGanttLicense } from "ngx-apexgantt"
import { AppComponent } from "./app/app.component"
import { appConfig } from "./app/app.config"

setApexGanttLicense("your-license-key-here")
bootstrapApplication(AppComponent, appConfig)

The community edition runs without a license key.

Performance with Large Angular Gantt Timelines

ApexGantt renders large project timelines quickly. On an Apple M4 Pro (apexgantt 3.11.1, headless Chromium):

~65 ms1,000 tasks
~275 ms5,000 tasks
~620 ms10,000 tasks

Angular Gantt Chart FAQ

How do I install ApexGantt for Angular?

Run npm install ngx-apexgantt apexgantt. Both packages are required: ngx-apexgantt is the Angular wrapper, and apexgantt is the core engine it depends on. Import NgxApexGanttComponent (standalone) or NgxApexGanttModule (module-based) from ngx-apexgantt.

Does ApexGantt work with Angular standalone components?

Yes. Add NgxApexGanttComponent to your standalone component's imports array and use ngx-apexgantt in the template. The package supports both standalone and module-based applications as first-class patterns.

How do I set the commercial license in an Angular app?

Call setApexGanttLicense("key") before bootstrapApplication in main.ts. The community edition runs without a license key.

How do I access chart methods programmatically?

Get a reference to the component with @ViewChild("ganttChart") ganttChart!: NgxApexGanttComponent, then call ganttChart.zoomIn(), ganttChart.zoomOut(), ganttChart.update(options), ganttChart.updateTask(taskId, data), or ganttChart.destroy().

Does ApexGantt support TypeScript in Angular?

Yes. Type definitions ship with the package, covering the component, GanttOptions, TaskInput, ColumnKey, and event detail types (TaskUpdateSuccessEventDetail, TaskDraggedEventDetail, and more). No separate @types/ install is required.

Does ApexGantt support critical path and baselines?

Yes. Critical path highlighting and baseline (planned-vs-actual) tracking are built in, configurable through the same GanttOptions you use for everything else. Worked demos live at /apexgantt/demos/critical-path/ and /apexgantt/demos/baseline/.

Ready to build your Angular project timeline?

The fastest path is the demos: running examples you can read and copy from.

See ApexGantt Demos

Why Vue Teams Choose ApexGantt

The vue-apexgantt package exposes the chart as a real Vue 3 component, <ApexGanttChart />, with reactive props, typed emits, template refs, and a useGanttData composable, not a thin shell around an imperative library that leaves you fighting reactive proxies and template refs that don't behave like Vue components should. It shares its core engine with ApexGantt's React, Angular, and JavaScript wrappers, so the task data model stays consistent if your stack grows beyond Vue. Learn about the full ApexGantt component →

Drag-and-Drop Scheduling, Wired to Reactive State

Drag tasks to reschedule, resize bars, and draw dependency arrows on the timeline. Bind the @task-dragged, @task-resized, and @task-update-success emits to update your reactive state, and the chart reflects it. Watch the scripted plan move, then grab a bar yourself.


Critical Path That Recomputes on Every Edit

ApexGantt highlights the longest chain of dependent tasks that drives your finish date. Mutate a ref()-backed task or call update() on the template ref and the critical path recomputes automatically. Watch it re-route between the two branches below.


Baselines for Planned vs. Actual

Attach a planned (baseline) range to each task in the same tasks array and ApexGantt draws a thin reference bar beneath the live one, so schedule variance is visible at a glance. No separate data structure required. The demo drifts the actuals past plan to show a slipping project.


Multiple View Modes via a Single Prop

Bind the pixels-per-day prop (a number; the header tier auto-picks from year down to minute) to control timeline density reactively, with no data re-query. This one auto-zooms; interact to take the controls.

Task Dependencies

Finish-to-start, start-to-start, and finish-to-finish links with lag, set on the :tasks you bind.

Milestones

Zero-duration diamond markers for gates, releases, and key dates.

Annotations

Pin sprint boundaries, deadlines, or notes to specific dates via options.annotations.

Resizable Sidebar

A resizable task list that adapts to long task names or more timeline room.

Rich HTML Tooltips

Templatable tooltips showing dates, duration, progress, and dependencies.

Custom Colors & Dark Theme

Bind :theme reactively for a runtime toggle; deeper styling via the options prop.

SVG Export

Export timelines to high-quality SVG with every task and dependency preserved.

TypeScript Types

Definitions ship for the ApexGanttChart props, TaskInput, GanttUserOptions, ParsingConfig, and emits.

Install in Your Vue 3 App

ApexGantt for Vue requires two packages: the Vue wrapper and the core engine. It is a Vue 3 wrapper using the Composition API and requires Vue 3.3 or later (peer dependency vue ^3.3.0); Vue 2 is not supported.

npm install vue-apexgantt apexgantt
# or
pnpm add vue-apexgantt apexgantt
# or
yarn add vue-apexgantt apexgantt

A complete working Gantt chart in one Single File Component:

<template>
  <ApexGanttChart
    :tasks="tasks"
    :pixels-per-day="25.7"
    height="500px"
  />
</template>

<script setup lang="ts">
import { ref } from "vue"
import { ApexGanttChart } from "vue-apexgantt"
import type { TaskInput } from "vue-apexgantt"

const tasks = ref<TaskInput[]>([
  { id: "task-1", name: "Design",      startTime: "01-01-2026", endTime: "01-15-2026", progress: 75 },
  { id: "task-2", name: "Development", startTime: "01-16-2026", endTime: "02-28-2026", progress: 40, dependency: "task-1" },
  { id: "task-3", name: "QA",          startTime: "03-01-2026", endTime: "03-15-2026", progress: 0,  dependency: "task-2" }
])
</script>

Props use camelCase in script and kebab-case in templates (pixels-per-day, class-name).

Handling Events in Vue

Vue emits use kebab-case in templates. Bind handlers with @event-name, and reach imperative methods through a template ref:

<template>
  <ApexGanttChart
    ref="ganttRef"
    :tasks="tasks"
    :pixels-per-day="25.7"
    height="600px"
    @task-dragged="handleTaskDragged"
    @task-resized="handleTaskResized"
    @task-update-success="handleTaskUpdateSuccess"
  />

  <button @click="ganttRef?.zoomIn()">Zoom In</button>
  <button @click="ganttRef?.zoomOut()">Zoom Out</button>
</template>

<script setup lang="ts">
import { ref } from "vue"
import { ApexGanttChart } from "vue-apexgantt"
import type {
  TaskDraggedEventDetail,
  TaskResizedEventDetail,
  TaskUpdateSuccessEventDetail
} from "vue-apexgantt"

const ganttRef = ref<InstanceType<typeof ApexGanttChart> | null>(null)

const handleTaskDragged = (d: TaskDraggedEventDetail) => console.log("dragged", d)
const handleTaskResized = (d: TaskResizedEventDetail) => console.log("resized", d)
const handleTaskUpdateSuccess = async (d: TaskUpdateSuccessEventDetail) => {
  await fetch(`/api/tasks/${d.taskId}`, { method: "PATCH", body: JSON.stringify(d.updatedTask) })
}
</script>

The wrapper exposes six emits (taskUpdate, taskUpdateSuccess, taskValidationError, taskUpdateError, taskDragged, taskResized) and template-ref methods zoomIn, zoomOut, update, updateTask, destroy, and getInstance.

Customization and Theming

Bind :theme reactively for a runtime toggle, and pass a Partial<GanttUserOptions> through the options prop for deeper control:

<template>
  <ApexGanttChart :tasks="tasks" :theme="theme" :options="ganttOptions" />
  <button @click="theme = theme === 'light' ? 'dark' : 'light'">Toggle theme</button>
</template>

<script setup lang="ts">
import { ref } from "vue"
import type { ThemeMode, GanttUserOptions } from "vue-apexgantt"

const theme = ref<ThemeMode>("light")

const ganttOptions: Partial<GanttUserOptions> = {
  enableTaskDrag: true,
  enableTaskResize: true,
  enableTaskEdit: true,
  barBackgroundColor: "#537CFA",
  rowBackgroundColors: ["#FFFFFF", "#F8F9FA"]
}
</script>

Mapping Your API Shape with useGanttData

API responses rarely match the field names ApexGantt expects. The useGanttData composable maps any shape, including nested paths via dot notation and value transforms, without hand-written code:

<script setup lang="ts">
import { ref } from "vue"
import { ApexGanttChart, useGanttData } from "vue-apexgantt"
import type { ParsingConfig } from "vue-apexgantt"

const apiData = ref([
  {
    project: {
      task:   { id: "T1", title: "Design" },
      dates:  { start: "01-01-2026", end: "01-15-2026" },
      status: { completion: 0.75 }
    }
  }
])

const parsingConfig: ParsingConfig = {
  id:        "project.task.id",
  name:      "project.task.title",
  startTime: "project.dates.start",
  endTime:   "project.dates.end",
  progress:  { key: "project.status.completion", transform: (v) => v * 100 }
}

const tasks = useGanttData({ data: apiData, parsing: parsingConfig })
</script>

<template>
  <ApexGanttChart :tasks="tasks" />
</template>

Dot notation pulls values from nested objects; the transform function converts unit-mismatched values, here a 0–1 completion ratio into a 0–100 percentage.

TypeScript Support in Vue

vue-apexgantt ships TypeScript definitions for every public surface:

import type {
  TaskInput,
  TaskType,
  ThemeMode,
  GanttUserOptions,
  ParsingConfig,
  TaskUpdateEventDetail,
  TaskUpdateSuccessEventDetail,
  TaskDraggedEventDetail,
  TaskResizedEventDetail
} from "vue-apexgantt"

Use these to type your refs, parsing configs, and event handlers. Volar picks them up in templates and <script setup> blocks.

Commercial License Setup

If you have a commercial ApexGantt license, set it once at application start, before createApp().mount():

// main.ts
import { createApp } from "vue"
import { setApexGanttLicense } from "vue-apexgantt"
import App from "./App.vue"

setApexGanttLicense("your-license-key-here")

createApp(App).mount("#app")

The community edition runs without a license key.

Performance with Large Vue Gantt Timelines

ApexGantt renders large project timelines quickly. On an Apple M4 Pro (apexgantt 3.11.1, headless Chromium):

~65 ms1,000 tasks
~275 ms5,000 tasks
~620 ms10,000 tasks

Vue Gantt Chart FAQ

How do I install ApexGantt for Vue?

Run npm install vue-apexgantt apexgantt. Both packages are required: vue-apexgantt is the Vue 3 wrapper, and apexgantt is the core engine. Import ApexGanttChart from vue-apexgantt and render it with a tasks prop.

Does ApexGantt work with Vue 2?

No. vue-apexgantt is a Vue 3 wrapper using the Composition API and requires Vue 3.3 or later (peer dependency vue ^3.3.0). Vue 2 is not supported.

How do I handle drag-and-drop updates in Vue state?

Bind the task-dragged, task-resized, and task-update-success emits to handler functions. Each emits a typed detail object containing the updated task; update your reactive state from the handler, and the chart reflects the change.

Does ApexGantt support TypeScript in Vue?

Yes. Full TypeScript definitions ship with the package, including TaskInput, GanttUserOptions, ThemeMode, ParsingConfig, and event detail types like TaskDraggedEventDetail and TaskResizedEventDetail.

How do I parse API data that doesn't match the ApexGantt schema?

Use the useGanttData composable. Pass your raw data and a ParsingConfig mapping your field names to ApexGantt's (id, name, startTime, endTime, progress, dependency). Dot notation handles nested objects; a transform function handles unit conversions.

Does ApexGantt support critical path and baselines?

Yes. Critical path highlighting and baseline (planned-vs-actual) tracking are built in, configurable through GanttUserOptions. Worked demos live at /apexgantt/demos/critical-path/ and /apexgantt/demos/baseline/.

Can ApexGantt handle large timelines?

Yes. In a benchmark on an Apple M4 Pro, ApexGantt rendered a 5,000-task timeline in about 275 ms and a 10,000-task timeline in about 620 ms (apexgantt 3.11.1).

Ready to build your Vue project timeline?

The fastest path is the demos: running examples you can read and copy from.

See ApexGantt Demos

Why React Teams Choose ApexGantt

The react-apexgantt wrapper exposes the chart as a real React component, <ApexGanttChart />, with props, events, refs, and hooks that match how React applications already work, not a thin shell around an imperative library that leaves you fighting refs and effect cleanup. It shares its core engine with ApexGantt's Angular, Vue, and JavaScript wrappers, so the task data and configuration API stay consistent if your stack grows beyond React. Learn about the full ApexGantt component →

Drag-and-Drop Scheduling, Driven by React State

Drag tasks to reschedule, resize bars to change durations, and draw dependency arrows, all on the timeline. Each interaction fires a typed callback (onTaskDragged, onTaskResized, onTaskUpdateSuccess) so you can persist the change to your backend or store, then pass the updated tasks back as a prop. Watch the scripted plan move, then grab a bar yourself.


Critical Path That Recomputes on Every Edit

ApexGantt highlights the longest chain of dependent tasks that drives your finish date. Update a task through props or the ref API and the critical path recomputes automatically, so a slip becomes visible the moment your React state changes. Watch it re-route between the two branches below.


Baselines for Planned vs. Actual

Attach a planned (baseline) range to each task in the same tasks array and ApexGantt draws a thin reference bar beneath the live one, so schedule variance is visible at a glance. No separate data structure, just an extra field on the task you already pass as a prop. The demo drifts the actuals past plan to show a slipping project.


Multiple View Modes via a Single Prop

Control timeline density with the pixelsPerDay prop (a number; the header tier auto-picks from year down to minute), with no data re-query. This one auto-zooms; interact to take the controls.

Task Dependencies

Finish-to-start, start-to-start, and finish-to-finish links with lag, set on the tasks you pass as a prop.

Milestones

Zero-duration diamond markers for gates, releases, and key dates.

Annotations

Pin sprint boundaries, deadlines, or notes to specific dates through the options prop.

Resizable Sidebar

A resizable task list that adapts to long task names or more timeline room.

Rich HTML Tooltips

Templatable tooltips showing dates, duration, progress, and dependencies.

Custom Colors & Dark Theme

Flip themes with the theme prop; deeper styling via the options object.

SVG Export

Export timelines to high-quality SVG with every task and dependency preserved.

TypeScript Types

Definitions ship for the ApexGanttChart props, TaskInput, GanttUserOptions, and the ref handle.

Install in Your React App

ApexGantt for React requires two packages: the React wrapper and the core engine. Install both:

npm install react-apexgantt apexgantt
# or
pnpm add react-apexgantt apexgantt
# or
yarn add react-apexgantt apexgantt

Import the component and pass a tasks array:

import React from "react"
import { ApexGanttChart } from "react-apexgantt"

export default function ProjectTimeline() {
  const tasks = [
    { id: "task-1", name: "Design",      startTime: "01-01-2026", endTime: "01-15-2026", progress: 75 },
    { id: "task-2", name: "Development", startTime: "01-16-2026", endTime: "02-28-2026", progress: 40, dependency: "task-1" },
    { id: "task-3", name: "QA",          startTime: "03-01-2026", endTime: "03-15-2026", progress: 0,  dependency: "task-2" }
  ]

  return <ApexGanttChart tasks={tasks} pixelsPerDay={25.7} height="500px" />
}

That's a complete, working React Gantt chart. Dependencies render as arrows between tasks. The pixelsPerDay prop takes a number; the header tier auto-picks from year down to minute as the value increases.

Working with React State and Events

ApexGantt's event callbacks keep your React state in sync with whatever the user does on the timeline. Drag a task and onTaskDragged fires; resize one and onTaskResized fires; finish an edit and onTaskUpdateSuccess fires with the resolved task.

import { useRef } from "react"
import { ApexGanttChart, type ApexGanttHandle } from "react-apexgantt"

export default function ScheduleEditor({ initialTasks }) {
  const ganttRef = useRef<ApexGanttHandle>(null)

  const handleTaskUpdateSuccess = async (detail) => {
    // persist to your backend
    await fetch(`/api/tasks/${detail.taskId}`, {
      method: "PATCH",
      body: JSON.stringify(detail.updatedTask)
    })
  }

  return (
    <ApexGanttChart
      ref={ganttRef}
      tasks={initialTasks}
      pixelsPerDay={25.7}
      height="600px"
      onTaskDragged={(d) => console.log("dragged", d)}
      onTaskResized={(d) => console.log("resized", d)}
      onTaskUpdateSuccess={handleTaskUpdateSuccess}
    />
  )
}

The wrapper exposes eight callbacks (onTaskUpdate, onTaskUpdateSuccess, onTaskUpdateError, onTaskValidationError, onTaskDragged, onTaskResized, onSelectionChange, onDependencyArrowUpdate) and an imperative ref handle with update, updateTask, zoomIn, zoomOut, destroy, and getInstance. The pattern works the same with Redux Toolkit, Zustand, Jotai, or React Query.

Mapping Your API Shape with useGanttData

API responses rarely match the exact field names ApexGantt expects. The useGanttData hook converts your shape into ApexGantt's task model without hand-written transformation code:

import { useGanttData, ApexGanttChart } from "react-apexgantt"

function ProjectTimeline({ apiData }) {
  const tasks = useGanttData({
    data: apiData,
    parsing: {
      id: "task_id",
      name: "task_name",
      startTime: "start_date",
      endTime: "end_date"
    }
  })

  return <ApexGanttChart tasks={tasks} pixelsPerDay={25.7} />
}

TypeScript Support in React

ApexGantt ships TypeScript definitions for the React component, the task data model, configuration options, and the ref handle. No @types/ package needed.

import {
  ApexGanttChart,
  type TaskInput,
  type GanttUserOptions,
  type ApexGanttHandle
} from "react-apexgantt"

const tasks: TaskInput[] = [
  { id: "task-1", name: "Design", startTime: "01-01-2026", endTime: "01-15-2026", progress: 0 }
]

const pixelsPerDay: number = 25.7

react-apexgantt peer-depends on react >=16.8.0 and react-dom >=16.8.0, so the floor is React 16.8+ and the open range covers React 17, 18, and 19.

Commercial License Setup

If you have a commercial ApexGantt license, set it once at application start, before any chart renders:

// main.tsx or index.tsx
import React from "react"
import ReactDOM from "react-dom/client"
import { setApexGanttLicense } from "react-apexgantt"
import App from "./App"

setApexGanttLicense("your-license-key-here")

ReactDOM.createRoot(document.getElementById("root")!).render(<App />)

The community edition runs without a license key.

Performance with Large React Gantt Timelines

ApexGantt renders large project timelines quickly. On an Apple M4 Pro (apexgantt 3.11.1, headless Chromium):

~65 ms1,000 tasks
~275 ms5,000 tasks
~620 ms10,000 tasks

React Gantt Chart FAQ

How do I install ApexGantt for React?

Run npm install react-apexgantt apexgantt. Both packages are required: react-apexgantt is the React wrapper, and apexgantt is the core engine it depends on. Import ApexGanttChart from react-apexgantt and render it with a tasks array.

Does ApexGantt support TypeScript?

Yes. Type definitions ship with the package, covering the ApexGanttChart component props, the TaskInput data model, GanttUserOptions configuration, and the ApexGanttHandle ref interface. No separate @types/ install is required.

How do I handle task drag-and-drop in React state?

Wire the onTaskDragged, onTaskResized, and onTaskUpdateSuccess callbacks to persist updates to your backend or update your local store. The chart fires each event with a detail object containing the updated task; pass the new task array back as a prop and the chart reflects the change.

Does ApexGantt support critical path and baselines?

Yes. Critical path highlighting and baseline (planned-vs-actual) tracking are both built in. They use the same task data model and ship with worked demos.

How do I set the ApexGantt commercial license in a React app?

Import setApexGanttLicense from react-apexgantt and call it once at application start, typically in main.tsx or index.tsx, before rendering any chart. The community edition runs without a license key.

Can ApexGantt handle large React Gantt timelines?

Yes. In a benchmark on an Apple M4 Pro, ApexGantt rendered a 5,000-task timeline in about 275 ms and a 10,000-task timeline in about 620 ms (apexgantt 3.11.1).

Ready to build your React project timeline?

The fastest path is the demos: running examples you can read and copy from.

See ApexGantt Demos